package com.woolha.jpamulticolumnselect.controller;

import com.woolha.jpamulticolumnselect.service.OrderService;
import java.util.UUID;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/orders")
@RequiredArgsConstructor
public class OrderController {

  private final OrderService orderService;

  @GetMapping("/{id}/interface-projection")
  public void fetchWithInterfaceProjection(@PathVariable UUID id) {
    this.orderService.fetchWithInterfaceProjection(id);
  }

  @GetMapping("/nested-interface-projection")
  public void fetchWithNestedInterfaceProjection(@RequestParam UUID userId) {
    this.orderService.fetchWithNestedInterfaceProjection(userId);
  }

  @GetMapping("/scalar-projection")
  public void fetchWithScalarProjection(@RequestParam UUID userId) {
    this.orderService.fetchWithScalarProjection(userId);
  }

  @GetMapping("/{orderNumber}/class-projection")
  public void fetchWithClassProjection(@PathVariable String orderNumber) {
    this.orderService.fetchWithClassProjection(orderNumber);
  }

  @GetMapping("/{id}/criteria-query")
  public void fetchWithCriteriaQuery(@PathVariable UUID id) {
    this.orderService.fetchWithCriteriaQuery(id);
  }

  @GetMapping("/{id}/criteria-query-join")
  public void fetchWithCriteriaQueryWithJoin(@PathVariable UUID id) {
    this.orderService.fetchWithCriteriaQueryWithJoin(id);
  }
}
