package com.woolha.jpamulticolumnselect.model;

import jakarta.persistence.Entity;
import jakarta.persistence.FetchType;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.Id;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;
import java.math.BigDecimal;
import java.time.ZonedDateTime;
import java.util.Map;
import java.util.Set;
import java.util.UUID;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.JdbcTypeCode;
import org.hibernate.id.uuid.UuidGenerator;
import org.hibernate.type.SqlTypes;

@AllArgsConstructor
@NoArgsConstructor
@Builder
@Getter
@Setter
@Entity
@Table(name = "orders")
public class Order {

  @Id
  @GeneratedValue
  @GenericGenerator(name = "UUID", type = UuidGenerator.class)
  private UUID id;

  private String orderNumber;

  private BigDecimal totalPrice;

  private ZonedDateTime createdAt;

  private UUID userId;

  private String note;

  @JdbcTypeCode(SqlTypes.JSON)
  private Map<String, Object> detail;

  @OneToMany(fetch = FetchType.LAZY, mappedBy = "order")
  private Set<OrderLine> orderLines;
}
