package com.woolha.jpamulticolumnselect.model.projection;

import java.math.BigDecimal;
import java.time.ZonedDateTime;
import java.util.List;
import java.util.UUID;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
public class OrderWithLinesDto {

  private UUID id;

  private String orderNumber;

  private BigDecimal totalPrice;

  private ZonedDateTime createdAt;

  private List<OrderLineDto> orderLines;

  public OrderWithLinesDto(
      UUID id,
      String orderNumber,
      BigDecimal totalPrice,
      ZonedDateTime createdAt,
      List<OrderLineDto> orderLines
  ) {
    this.id = id;
    this.orderNumber = orderNumber;
    this.totalPrice = totalPrice;
    this.createdAt = createdAt;
    this.orderLines = orderLines;
  }

  @Getter
  @Setter
  @AllArgsConstructor
  public static class OrderLineDto {

    private UUID id;

    private int quantity;

    private String productName;

    private BigDecimal price;
  }
}
