package com.woolha.jpamulticolumnselect.repository;

import com.woolha.jpamulticolumnselect.model.Order;
import com.woolha.jpamulticolumnselect.model.projection.OrderDto;
import com.woolha.jpamulticolumnselect.model.projection.OrderView;
import com.woolha.jpamulticolumnselect.model.projection.OrderWithLinesView;
import java.util.List;
import java.util.Optional;
import java.util.UUID;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

public interface OrderRepository extends JpaRepository<Order, UUID>,
    CustomOrderRepository {

  Optional<OrderView> findOneProjectedById(UUID id);

  List<OrderWithLinesView> findAllProjectedWithLinesByUserId(UUID id);

  @Query("SELECT o.id, o.orderNumber, o.totalPrice, o.createdAt FROM Order o WHERE userId = :userId")
  List<Object[]> findAllProjectedByUserId(@Param("userId") UUID userId);

  // The @Query annotation is only necessary if the class has multiple constructors and/or different fields
  @Query(
      "SELECT new com.woolha.jpamulticolumnselect.model.projection.OrderDto(o.id, o.orderNumber, o.totalPrice, o.createdAt)"
          + " FROM Order o"
          + " WHERE orderNumber = :orderNumber"
  )
  Optional<OrderDto> findOneProjectedByOrderNumber(@Param("orderNumber") String orderNumber);
}
