CREATE TABLE IF NOT EXISTS public."orders"
(
  id            uuid            NOT NULL,
  order_number  text            NOT NULL,
  total_price   numeric(19, 2)  NOT NULL,
  created_at    timestamptz     NOT NULL,
  user_id       uuid            NOT NULL,
  note          text            NOT NULL,
  detail        jsonb           NOT NULL,
  CONSTRAINT "pk_orders" PRIMARY KEY (id)
);

CREATE TABLE IF NOT EXISTS public."order_lines"
(
  id            uuid            NOT NULL,
  order_id      uuid            NOT NULL,
  quantity      int             NOT NULL,
  product_name  text            NOT NULL,
  price         numeric(19, 2)  NOT NULL,
  note          text            NOT NULL,
  CONSTRAINT "pk_order_lines" PRIMARY KEY (id),
  CONSTRAINT "fk_order_lines_order_id" FOREIGN KEY(order_id) REFERENCES orders(id)
);

INSERT INTO orders
  VALUES('09af2dc3-b6db-4869-b00f-9ee02ce37f71', '1234', 10, NOW(), '6e047d38-03af-43a0-9404-e7ebb64cb13e', 'Note...', '{}');

INSERT INTO order_lines
  VALUES('70ee8fca-a3d6-4151-a743-8a49ee6e124f', '09af2dc3-b6db-4869-b00f-9ee02ce37f71', 1, 'Cow', 1000, 'Note...');
INSERT INTO order_lines
  VALUES('003772de-f875-4f43-b4d1-3187538a2a02', '09af2dc3-b6db-4869-b00f-9ee02ce37f71', 1, 'Goat', 1100, 'Note...');

INSERT INTO orders
  VALUES('ae2a557a-5a5f-445e-8b11-febc0ec5649d', '1111', 11, NOW(), '6e047d38-03af-43a0-9404-e7ebb64cb13e', 'Note...', '{}');

INSERT INTO order_lines
  VALUES('c39863d5-ebfe-46d1-b998-3774454c70f4', 'ae2a557a-5a5f-445e-8b11-febc0ec5649d', 1, 'Camel', 1200, 'Note...');
